]> git.draconx.ca Git - gentoo-draconx.git/commitdiff
mesa: Add 7.11-rc1 with intel unfuckage.
authorNick Bowler <nbowler@elliptictech.com>
Tue, 19 Jul 2011 02:31:13 +0000 (22:31 -0400)
committerNick Bowler <nbowler@elliptictech.com>
Tue, 19 Jul 2011 02:31:13 +0000 (22:31 -0400)
media-libs/mesa/Manifest [new file with mode: 0644]
media-libs/mesa/files/0001-i965-gen4-Fix-GPU-hangs-since-the-program-streaming-.patch [new file with mode: 0644]
media-libs/mesa/files/eselect-mesa.conf.7.11 [new file with mode: 0644]
media-libs/mesa/files/glx_ro_text_segm.patch [new file with mode: 0644]
media-libs/mesa/mesa-7.11_rc1-r1.ebuild [new file with mode: 0644]

diff --git a/media-libs/mesa/Manifest b/media-libs/mesa/Manifest
new file mode 100644 (file)
index 0000000..52857d1
--- /dev/null
@@ -0,0 +1,5 @@
+AUX 0001-i965-gen4-Fix-GPU-hangs-since-the-program-streaming-.patch 1742 RMD160 2407d8f1f91eefb0ca55c3389873d223581b2cd7 SHA1 6d7dd0834679b6b24bb968d24fc585b0d75a8773 SHA256 4d79ad810a462bf0c42a0e6c744a38f15df5d1a9959f60b2e0a8530db130978a
+AUX eselect-mesa.conf.7.11 1670 RMD160 74d85b0481f36a8e2b2e09245d49d09671500946 SHA1 5c5f468feaae946e5901698d1c0ffe8fc480b783 SHA256 448d08e97e931563aa2e33f22feeaf911caf9a2eb9fd7b446485311d1dcc1225
+AUX glx_ro_text_segm.patch 731 RMD160 6d2bd85591d6349fa45a5ee16c724859c640e902 SHA1 3015aa2bd139bcdf2c3fae61f460f0c5aaeb1df7 SHA256 e36af5b530fdbe2b0e62a035bf4bf4baef267c3dc56133d1a58e56899ebffc5c
+DIST MesaLib-7.11-rc1.tar.bz2 6329407 RMD160 d25e1425af095ed8056a26160611d70b2ad36673 SHA1 8faa738a86fe374541603168d9ff26adad5baf65 SHA256 5697c807b8438e311dc029c1d75d8296597e200b6c1de1d2576467700dce6103
+EBUILD mesa-7.11_rc1-r1.ebuild 9909 RMD160 857f976bd80e0379717e0246dd4819d48d2857a8 SHA1 7c1ce0bad8afe401161db586a02cec2f9761c74c SHA256 fb2de2a72ebd81780333ffc0229f03fcee2d956073151f400dc1bc686b5567d4
diff --git a/media-libs/mesa/files/0001-i965-gen4-Fix-GPU-hangs-since-the-program-streaming-.patch b/media-libs/mesa/files/0001-i965-gen4-Fix-GPU-hangs-since-the-program-streaming-.patch
new file mode 100644 (file)
index 0000000..2b385d2
--- /dev/null
@@ -0,0 +1,40 @@
+From 804995807dfea9cbdbd676e52b95d42715101913 Mon Sep 17 00:00:00 2001
+From: Eric Anholt <eric@anholt.net>
+Date: Fri, 8 Jul 2011 15:30:48 -0700
+Subject: [PATCH] i965/gen4: Fix GPU hangs since the program streaming change.
+
+This was tricky.  We were doing a use-before-initialize of
+grf_reg_count, but the value usually got overwritten anyway -- when we
+didn't have to do a relocation (typical), or on gen5 when we didn't
+have relocations at all.
+
+Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=38771
+Reviewed-by: Kenneth Graunke <kenneth@whitecape.org>
+(cherry picked from commit d03fdc4cdefdfdc5b59547945704c6037a5061c7)
+---
+ src/mesa/drivers/dri/i965/brw_vs_state.c |    2 +-
+ 1 files changed, 1 insertions(+), 1 deletions(-)
+
+diff --git a/src/mesa/drivers/dri/i965/brw_vs_state.c b/src/mesa/drivers/dri/i965/brw_vs_state.c
+index d5010a2..179ca19 100644
+--- a/src/mesa/drivers/dri/i965/brw_vs_state.c
++++ b/src/mesa/drivers/dri/i965/brw_vs_state.c
+@@ -47,6 +47,7 @@ brw_prepare_vs_unit(struct brw_context *brw)
+    memset(vs, 0, sizeof(*vs));
+    /* BRW_NEW_PROGRAM_CACHE | CACHE_NEW_VS_PROG */
++   vs->thread0.grf_reg_count = ALIGN(brw->vs.prog_data->total_grf, 16) / 16 - 1;
+    vs->thread0.kernel_start_pointer =
+       brw_program_reloc(brw,
+                       brw->vs.state_offset +
+@@ -54,7 +55,6 @@ brw_prepare_vs_unit(struct brw_context *brw)
+                       brw->vs.prog_offset +
+                       (vs->thread0.grf_reg_count << 1)) >> 6;
+-   vs->thread0.grf_reg_count = ALIGN(brw->vs.prog_data->total_grf, 16) / 16 - 1;
+    vs->thread1.floating_point_mode = BRW_FLOATING_POINT_NON_IEEE_754;
+    /* Choosing multiple program flow means that we may get 2-vertex threads,
+     * which will have the channel mask for dwords 4-7 enabled in the thread,
+-- 
+1.7.3.4
+
diff --git a/media-libs/mesa/files/eselect-mesa.conf.7.11 b/media-libs/mesa/files/eselect-mesa.conf.7.11
new file mode 100644 (file)
index 0000000..3a1b196
--- /dev/null
@@ -0,0 +1,39 @@
+# mesa classic/gallium implementations in this release
+
+# Syntax description:
+# * MESA_IMPLEMENTATIONS contains a space-delimited list of switchable
+#   classic/gallium implementations.
+# * MESA_DRIVERS is an associative array, for each member "foo" of
+#   MESA_IMPLEMENTATIONS it contains the following elements:
+#   foo,description - Human-readable description of the driver
+#   foo,classicdriver - Filename of the classic driver
+#   foo,galliumdriver - Filename of the gallium driver
+#   foo,default - which of classic or gallium is chosen by default
+
+MESA_IMPLEMENTATIONS="i915 i965 r300 r600 sw"
+declare -A MESA_DRIVERS || die "MESA_DRIVERS already in environment and not associative."
+
+MESA_DRIVERS[i915,description]="i915 (Intel 915, 945)"
+MESA_DRIVERS[i915,classicdriver]="i915_dri.so"
+MESA_DRIVERS[i915,galliumdriver]="i915g_dri.so"
+MESA_DRIVERS[i915,default]="classic"
+
+MESA_DRIVERS[i965,description]="i965 (Intel 965, G/Q3x, G/Q4x)"
+MESA_DRIVERS[i965,classicdriver]="i965_dri.so"
+MESA_DRIVERS[i965,galliumdriver]="i965g_dri.so"
+MESA_DRIVERS[i965,default]="classic"
+
+MESA_DRIVERS[r300,description]="r300 (Radeon R300-R500)"
+MESA_DRIVERS[r300,classicdriver]="r300_dri.so"
+MESA_DRIVERS[r300,galliumdriver]="r300g_dri.so"
+MESA_DRIVERS[r300,default]="gallium"
+
+MESA_DRIVERS[r600,description]="r600 (Radeon R600-R700, Evergreen, Northern Islands)"
+MESA_DRIVERS[r600,classicdriver]="r600_dri.so"
+MESA_DRIVERS[r600,galliumdriver]="r600g_dri.so"
+MESA_DRIVERS[r600,default]="gallium"
+
+MESA_DRIVERS[sw,description]="sw (Software renderer)"
+MESA_DRIVERS[sw,classicdriver]="swrast_dri.so"
+MESA_DRIVERS[sw,galliumdriver]="swrastg_dri.so"
+MESA_DRIVERS[sw,default]="gallium"
diff --git a/media-libs/mesa/files/glx_ro_text_segm.patch b/media-libs/mesa/files/glx_ro_text_segm.patch
new file mode 100644 (file)
index 0000000..495b7dc
--- /dev/null
@@ -0,0 +1,28 @@
+2011-02-09     Jeremy Huddleston <jeremyhu@freedesktop.org
+
+       #240956
+       * configure.ac  add support to enable readonly test segment on x86
+
+--- configure.ac.orig  2008-11-17 23:19:38.000000000 +0100
++++ configure.ac       2008-11-17 23:20:17.000000000 +0100
+@@ -499,6 +499,20 @@
+     enable_xcb=no
+ fi
++
++dnl readonly text segment on x86 hardened platforms
++AC_ARG_ENABLE([glx_rts],
++    [AS_HELP_STRING([--enable-glx-rts],
++        [on x86, use a readonly text segment for libGL @<:@default=disabled@:>@])],
++    [enable_glx_rts="$enableval"],
++    [enable_glx_rts=no])
++if test "x$enable_glx_rts" = xyes; then
++    DEFINES="$DEFINES -DGLX_X86_READONLY_TEXT"
++else
++    enable_glx_rts=no
++fi
++
++
+ dnl
+ dnl libGL configuration per driver
+ dnl
diff --git a/media-libs/mesa/mesa-7.11_rc1-r1.ebuild b/media-libs/mesa/mesa-7.11_rc1-r1.ebuild
new file mode 100644 (file)
index 0000000..4cdb9f5
--- /dev/null
@@ -0,0 +1,368 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/media-libs/mesa/mesa-7.11_rc1-r1.ebuild,v 1.1 2011/07/10 10:17:14 chithanh Exp $
+
+EAPI=3
+
+EGIT_REPO_URI="git://anongit.freedesktop.org/mesa/mesa"
+
+if [[ ${PV} = 9999* ]]; then
+       GIT_ECLASS="git-2"
+       EXPERIMENTAL="true"
+fi
+
+inherit base autotools multilib flag-o-matic python toolchain-funcs ${GIT_ECLASS}
+
+OPENGL_DIR="xorg-x11"
+
+MY_PN="${PN/m/M}"
+MY_P="${MY_PN}-${PV/_/-}"
+MY_SRC_P="${MY_PN}Lib-${PV/_/-}"
+
+FOLDER="${PV/_rc*/}"
+
+DESCRIPTION="OpenGL-like graphic library for Linux"
+HOMEPAGE="http://mesa3d.sourceforge.net/"
+
+#SRC_PATCHES="mirror://gentoo/${P}-gentoo-patches-01.tar.bz2"
+if [[ $PV = 9999* ]]; then
+       SRC_URI="${SRC_PATCHES}"
+else
+       SRC_URI="ftp://ftp.freedesktop.org/pub/mesa/${FOLDER}/${MY_SRC_P}.tar.bz2
+               ${SRC_PATCHES}"
+fi
+
+LICENSE="LGPL-2 kilgard"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sh ~sparc ~x86 ~x86-fbsd ~x86-freebsd ~amd64-linux ~ia64-linux ~x86-linux ~sparc-solaris ~x64-solaris ~x86-solaris"
+
+INTEL_CARDS="intel"
+RADEON_CARDS="radeon"
+VIDEO_CARDS="${INTEL_CARDS} ${RADEON_CARDS} mach64 mga nouveau r128 savage sis vmware tdfx via"
+for card in ${VIDEO_CARDS}; do
+       IUSE_VIDEO_CARDS+=" video_cards_${card}"
+done
+
+IUSE="${IUSE_VIDEO_CARDS}
+       bindist +classic debug +egl +gallium gles +llvm motif +nptl openvg pic selinux shared-dricore +shared-glapi kernel_FreeBSD"
+
+LIBDRM_DEPSTRING=">=x11-libs/libdrm-2.4.24"
+# not a runtime dependency of this package, but dependency of packages which
+# depend on this package, bug #342393
+EXTERNAL_DEPEND="
+       >=x11-proto/dri2proto-2.2
+       >=x11-proto/glproto-1.4.11
+"
+# keep correct libdrm and dri2proto dep
+# keep blocks in rdepend for binpkg
+RDEPEND="${EXTERNAL_DEPEND}
+       !<x11-base/xorg-server-1.7
+       !<=x11-proto/xf86driproto-2.0.3
+       classic? ( app-admin/eselect-mesa )
+       gallium? ( app-admin/eselect-mesa )
+       app-admin/eselect-opengl
+       dev-libs/expat
+       dev-libs/libxml2[python]
+       x11-libs/libICE
+       >=x11-libs/libX11-1.3.99.901
+       x11-libs/libXdamage
+       x11-libs/libXext
+       x11-libs/libXi
+       x11-libs/libXmu
+       x11-libs/libXxf86vm
+       motif? ( x11-libs/openmotif )
+       gallium? (
+               llvm? ( >=sys-devel/llvm-2.9 )
+       )
+       ${LIBDRM_DEPSTRING}[video_cards_nouveau?,video_cards_vmware?]
+"
+for card in ${INTEL_CARDS}; do
+       RDEPEND="${RDEPEND}
+               video_cards_${card}? ( ${LIBDRM_DEPSTRING}[video_cards_intel] )
+       "
+done
+
+for card in ${RADEON_CARDS}; do
+       RDEPEND="${RDEPEND}
+               video_cards_${card}? ( ${LIBDRM_DEPSTRING}[video_cards_radeon] )
+       "
+done
+
+DEPEND="${RDEPEND}
+       =dev-lang/python-2*
+       dev-util/pkgconfig
+       x11-misc/makedepend
+       x11-proto/inputproto
+       >=x11-proto/xextproto-7.0.99.1
+       x11-proto/xf86driproto
+       x11-proto/xf86vidmodeproto
+"
+
+S="${WORKDIR}/${MY_P}"
+
+# It is slow without texrels, if someone wants slow
+# mesa without texrels +pic use is worth the shot
+QA_EXECSTACK="usr/lib*/opengl/xorg-x11/lib/libGL.so*"
+QA_WX_LOAD="usr/lib*/opengl/xorg-x11/lib/libGL.so*"
+
+# Think about: ggi, fbcon, no-X configs
+
+pkg_setup() {
+       # gcc 4.2 has buggy ivopts
+       if [[ $(gcc-version) = "4.2" ]]; then
+               append-flags -fno-ivopts
+       fi
+
+       # recommended by upstream
+       append-flags -ffast-math
+
+       python_set_active_version 2
+       python_pkg_setup
+}
+
+src_unpack() {
+       default
+       [[ $PV = 9999* ]] && git-2_src_unpack
+}
+
+src_prepare() {
+       # apply patches
+       if [[ ${PV} != 9999* && -n ${SRC_PATCHES} ]]; then
+               EPATCH_FORCE="yes" \
+               EPATCH_SOURCE="${WORKDIR}/patches" \
+               EPATCH_SUFFIX="patch" \
+               epatch
+       fi
+
+       epatch "${FILESDIR}"/0001-i965-gen4-Fix-GPU-hangs-since-the-program-streaming-.patch
+
+       # fix for hardened, bug 240956
+       [[ ${PV} != 9999* ]] && epatch "${FILESDIR}"/glx_ro_text_segm.patch
+
+       # FreeBSD 6.* doesn't have posix_memalign().
+       if [[ ${CHOST} == *-freebsd6.* ]]; then
+               sed -i \
+                       -e "s/-DHAVE_POSIX_MEMALIGN//" \
+                       configure.ac || die
+       fi
+       # Solaris needs some recent POSIX stuff in our case
+       if [[ ${CHOST} == *-solaris* ]] ; then
+               sed -i -e "s/-DSVR4/-D_POSIX_C_SOURCE=200112L/" configure.ac || die
+               sed -i -e 's/uint/unsigned int/g' src/egl/drivers/glx/egl_glx.c || die
+       fi
+
+       # In order for mesa to complete it's build process we need to use a tool
+       # that it compiles. When we cross compile this clearly does not work
+       # so we require mesa to be built on the host system first. -solar
+       if tc-is-cross-compiler; then
+               sed -i -e "s#^GLSL_CL = .*\$#GLSL_CL = glsl_compiler#g" \
+                       "${S}"/src/mesa/shader/slang/library/Makefile || die
+       fi
+
+       # depend contains strange paths, we don't want them
+       echo "" > "${S}"/src/mesa/depend || die
+
+       base_src_prepare
+
+       eautoreconf
+}
+
+src_configure() {
+       local myconf
+
+       if use classic; then
+       # Configurable DRI drivers
+               driver_enable swrast
+               driver_enable video_cards_intel i810 i915 i965
+               driver_enable video_cards_nouveau nouveau
+               driver_enable video_cards_mach64 mach64
+               driver_enable video_cards_mga mga
+               driver_enable video_cards_r128 r128
+               driver_enable video_cards_radeon radeon r200 r300 r600
+               driver_enable video_cards_savage savage
+               driver_enable video_cards_sis sis
+               driver_enable video_cards_tdfx tdfx
+               driver_enable video_cards_via unichrome
+       fi
+
+       myconf+="
+               $(use_enable !bindist texture-float)
+               $(use_enable gles gles1)
+               $(use_enable gles gles2)
+               $(use_enable egl)
+               $(use_enable openvg)
+       "
+       if use egl; then
+               use shared-glapi || die "egl needs shared-glapi. Please either enable shared-glapi or disable the egl use flag ."
+               myconf+="
+                       --with-egl-platforms=drm,x11
+                       $(use_enable gallium gallium-egl)
+               "
+       fi
+
+       if use !gallium && use !classic; then
+               ewarn "You enabled neither classic nor gallium USE flags. No hardware"
+               ewarn "drivers will be built."
+       fi
+       if use gallium; then
+               myconf+="
+                       --with-state-trackers=glx,dri$(use egl && echo ",egl")$(use openvg && echo ",vega")
+                       $(use_enable llvm gallium-llvm)
+               "
+               gallium_enable swrast
+               gallium_enable video_cards_vmware svga
+               gallium_enable video_cards_nouveau nouveau
+               gallium_enable video_cards_intel i915 i965
+               gallium_enable video_cards_radeon r300 r600
+       fi
+
+       # x86 hardened needs glx-rts, bug 240956
+       if use hardened; then
+               myconf+="
+                       $(use_enable x86 glx-rts)
+               "
+       fi
+
+       # --with-driver=dri|xlib|osmesa || do we need osmesa?
+       econf \
+               --disable-option-checking \
+               --with-driver=dri \
+               --disable-glut \
+               --without-demos \
+               --enable-xcb \
+               $(use_enable debug) \
+               $(use_enable motif glw) \
+               $(use_enable motif) \
+               $(use_enable nptl glx-tls) \
+               $(use_enable !pic asm) \
+               $(use_enable shared-dricore) \
+               $(use_enable shared-glapi) \
+               --with-dri-drivers=${DRI_DRIVERS} \
+               --with-gallium-drivers=${GALLIUM_DRIVERS} \
+               ${myconf}
+}
+
+src_install() {
+       base_src_install
+
+       # Save the glsl-compiler for later use
+       if ! tc-is-cross-compiler; then
+               dobin "${S}"/src/glsl/glsl_compiler || die
+       fi
+       # Remove redundant headers
+       # GLUT thing
+       rm -f "${ED}"/usr/include/GL/glut*.h || die "Removing glut include failed."
+       # Glew includes
+       rm -f "${ED}"/usr/include/GL/{glew,glxew,wglew}.h \
+               || die "Removing glew includes failed."
+
+       # Install config file for eselect mesa
+       insinto /usr/share/mesa
+       newins "${FILESDIR}/eselect-mesa.conf.7.11" eselect-mesa.conf || die
+
+       # Move libGL and others from /usr/lib to /usr/lib/opengl/blah/lib
+       # because user can eselect desired GL provider.
+       ebegin "Moving libGL and friends for dynamic switching"
+               dodir /usr/$(get_libdir)/opengl/${OPENGL_DIR}/{lib,extensions,include}
+               local x
+               for x in "${ED}"/usr/$(get_libdir)/libGL.{la,a,so*}; do
+                       if [ -f ${x} -o -L ${x} ]; then
+                               mv -f "${x}" "${ED}"/usr/$(get_libdir)/opengl/${OPENGL_DIR}/lib \
+                                       || die "Failed to move ${x}"
+                       fi
+               done
+               for x in "${ED}"/usr/include/GL/{gl.h,glx.h,glext.h,glxext.h}; do
+                       if [ -f ${x} -o -L ${x} ]; then
+                               mv -f "${x}" "${ED}"/usr/$(get_libdir)/opengl/${OPENGL_DIR}/include \
+                                       || die "Failed to move ${x}"
+                       fi
+               done
+       eend $?
+
+       if use classic || use gallium; then
+                       ebegin "Moving DRI/Gallium drivers for dynamic switching"
+                       local gallium_drivers=( i915_dri.so i965_dri.so r300_dri.so r600_dri.so swrast_dri.so )
+                       keepdir /usr/$(get_libdir)/dri
+                       dodir /usr/$(get_libdir)/mesa
+                       for x in ${gallium_drivers[@]}; do
+                               if [ -f "${S}/$(get_libdir)/gallium/${x}" ]; then
+                                       mv -f "${ED}/usr/$(get_libdir)/dri/${x}" "${ED}/usr/$(get_libdir)/dri/${x/_dri.so/g_dri.so}" \
+                                               || die "Failed to move ${x}"
+                                       insinto "/usr/$(get_libdir)/dri/"
+                                       if [ -f "${S}/$(get_libdir)/${x}" ]; then
+                                               insopts -m0755
+                                               doins "${S}/$(get_libdir)/${x}" || die "failed to install ${x}"
+                                       fi
+                               fi
+                       done
+                       for x in "${ED}"/usr/$(get_libdir)/dri/*.so; do
+                               if [ -f ${x} -o -L ${x} ]; then
+                                       mv -f "${x}" "${x/dri/mesa}" \
+                                               || die "Failed to move ${x}"
+                               fi
+                       done
+                       pushd "${ED}"/usr/$(get_libdir)/dri || die "pushd failed"
+                       ln -s ../mesa/*.so . || die "Creating symlink failed"
+                       # remove symlinks to drivers known to eselect
+                       for x in ${gallium_drivers[@]}; do
+                               if [ -f ${x} -o -L ${x} ]; then
+                                       rm "${x}" || die "Failed to remove ${x}"
+                               fi
+                       done
+                       popd
+               eend $?
+       fi
+}
+
+pkg_postinst() {
+       # Switch to the xorg implementation.
+       echo
+       eselect opengl set --use-old ${OPENGL_DIR}
+       # Select classic/gallium drivers
+       if use classic || use gallium; then
+               eselect mesa set --auto
+       fi
+
+       # warn about patent encumbered texture-float
+       if use !bindist; then
+               elog "USE=\"bindist\" was not set. Potentially patent encumbered code was"
+               elog "enabled."
+       fi
+}
+
+# $1 - VIDEO_CARDS flag
+# other args - names of DRI drivers to enable
+# TODO: avoid code duplication for a more elegant implementation
+driver_enable() {
+       case $# in
+               # for enabling unconditionally
+               1)
+                       DRI_DRIVERS+=",$1"
+                       ;;
+               *)
+                       if use $1; then
+                               shift
+                               for i in $@; do
+                                       DRI_DRIVERS+=",${i}"
+                               done
+                       fi
+                       ;;
+       esac
+}
+
+gallium_enable() {
+       case $# in
+               # for enabling unconditionally
+               1)
+                       GALLIUM_DRIVERS+=",$1"
+                       ;;
+               *)
+                       if use $1; then
+                               shift
+                               for i in $@; do
+                                       GALLIUM_DRIVERS+=",${i}"
+                               done
+                       fi
+                       ;;
+       esac
+}